function [] = generate_feedopt_c( cfg, output_root, debug )

if( nargin < 3 ), debug = false; end

if( debug ), output_root = "toErase"; end

if( isfolder( output_root ) ), rmdir( output_root, 's' ); end

configType      = coder.OutputType('FeedoptDefaultConfig');
ctxType         = coder.OutputType('initFeedoptPlan');
resampleType    = coder.OutputType('ResampleState');
C               = coder.OutputType('constrCurvStructType');
splineType      = coder.OutputType('bspline_create');

global sqrt_calls sin_calls cos_calls cot_calls DebugConfig
sqrt_calls  = 0;
sin_calls   = 0;
cos_calls   = 0;
cot_calls   = 0;
DebugConfig = 0;

P0 = [0,0,0]';
trafo = false; HSC = false;
Doff = 0.0;
R10 = coder.typeof(0.0, [Inf,1 ], [1,0]);
R11 = coder.typeof(0.0, [Inf,Inf], [1,1]);

if( ~debug  )

    codegen('-config', cfg,'-d', output_root, '-o', 'opencn_matlab',...
        'constrGcodeInfoStructType',...
        'constrGcodeInfoStruct', '-args', paramsDefaultGCodeInfo( StructTypeName.MEX ),...
        'constrBaseSplineType',...
        'constrBaseSpline', '-args', paramsDefaultBaseSpline( StructTypeName.MEX ),...
        'constrSplineType',...
        'constrSpline', '-args', paramsDefaultSpline( StructTypeName.MEX ),...
        'constrAxesStructType',...
        'constrAxesStruct', '-args',        paramsDefaultAxes( StructTypeName.MEX ),...
        'constrToolStructType',...
        'constrToolStruct', '-args',        paramsDefaultTool( StructTypeName.MEX ),...
        'constrCurvStructType',...
        'constrCurvStruct', '-args', paramsDefaultCurv( StructTypeName.MEX ),...
        'constrHelixStruct', '-args', paramsDefaultHelix( StructTypeName.MEX ),...
        'constrHelixStructFromArcFeed', '-args', paramsDefaultHelixFromArcFeed( StructTypeName.MEX ), ...
        'constrLineStruct', '-args', paramsDefaultLine( StructTypeName.MEX ), ...
        'constrTransP5Struct', '-args', paramsDefaultTransition( StructTypeName.MEX ),...
        'CopyCurvStruct', '-args', C,...
        'angles2deg', '-args', coder.typeof( zeros( 3, 1 ) ),...
        'angles2rad', '-args', coder.typeof( zeros( 3, 1 ) ),...
        'anglesNormDin', '-args', paramsDefaultAnglesNormDim( StructTypeName.MEX ),...
        'FeedoptDefaultConfig',...
        'ConfigSetSource',      '-args', { configType, coder.typeof( ' ',    StructTypeName.dimFileName{ : } ) },...
        'setMachineAxisInConfig', '-args', {configType, coder.typeof( false, StructTypeName.dimMask{ : } ) },...
        'export_kinematics', '-args', { configType, coder.typeof( [], StructTypeName.dimR{ : } ), ...
                                coder.typeof( [], StructTypeName.dimM{ : } )},....
        'initFeedoptPlan', '-args', configType,...
        'EvalCurvStruct', '-args', {ctxType, C, R10},...
        'linspace', '-args', {0,0,0}, ...
        'bspline_create', '-args', { int32(4), linspace(0,1,10) },...
        'bspline_copy', '-args', splineType,...
        'ResampleState', '-args', {0, 0} , ...
        'resampleCurvOCN', '-args', { resampleType, splineType, ZSpdMode.NN, ...
        coder.typeof(0.0, [Inf, 1], [1,0]), ...
        0.0, 0.0, R10, R10, true },...
        'evalPositionFromU', '-args', { configType, C, C, 0 },...
        'ReadGCode', '-args', { configType, ....
                                ReadGCodeCmd.Load, ...
                                coder.typeof( ' ',    StructTypeName.dimFileName{ : } ) }, ...
        'FeedoptPlan', '-args', ctxType,...
        'PrintCurvStruct', '-args', { ctxType, C }...
        );
else


    disp( "Debug Feedopt" );
    msg = repmat( '0', StructTypeName.dimMsg{ 1 } );
    codegen('-config', cfg,'-d', output_root, '-o', 'opencn_matlab', ...
        'ocn_assert', '-args', { true, msg, msg });
end

end
